# coding: utf-8

"""
    Intrinio API

    Welcome to the Intrinio API! Through our Financial Data Marketplace, we offer a wide selection of financial data feed APIs sourced by our own proprietary processes as well as from many data vendors. For a complete API request / response reference please view the [Intrinio API documentation](https://docs.intrinio.com/documentation/api_v2). If you need additional help in using the API, please visit the [Intrinio website](https://intrinio.com) and click on the chat icon in the lower right corner.  # noqa: E501

    OpenAPI spec version: 2.76.3
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from intrinio_sdk.models.api_response_index import ApiResponseIndex  # noqa: F401,E501
from intrinio_sdk.models.security_summary import SecuritySummary  # noqa: F401,E501


class ApiResponseIndexConstituents(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'index': 'ApiResponseIndex',
        'date': 'date',
        'constituents': 'list[SecuritySummary]'
    }

    attribute_map = {
        'index': 'index',
        'date': 'date',
        'constituents': 'constituents'
    }

    def __init__(self, index=None, date=None, constituents=None):  # noqa: E501
        """ApiResponseIndexConstituents - a model defined in Swagger"""  # noqa: E501

        self._index = None
        self._date = None
        self._constituents = None
        self.discriminator = None

        if index is not None:
            self.index = index
        if date is not None:
            self.date = date
        if constituents is not None:
            self.constituents = constituents

    @property
    def index(self):
        """Gets the index of this ApiResponseIndexConstituents.  # noqa: E501

        The index  # noqa: E501

        :return: The index of this ApiResponseIndexConstituents.  # noqa: E501
        :rtype: ApiResponseIndex
        """
        return self._index
        
    @property
    def index_dict(self):
        """Gets the index of this ApiResponseIndexConstituents.  # noqa: E501

        The index as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The index of this ApiResponseIndexConstituents.  # noqa: E501
        :rtype: ApiResponseIndex
        """

        result = None

        value = self.index
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'index': value }

        
        return result
        

    @index.setter
    def index(self, index):
        """Sets the index of this ApiResponseIndexConstituents.

        The index  # noqa: E501

        :param index: The index of this ApiResponseIndexConstituents.  # noqa: E501
        :type: ApiResponseIndex
        """

        self._index = index

    @property
    def date(self):
        """Gets the date of this ApiResponseIndexConstituents.  # noqa: E501

        The date when an update was last received for the index constituents  # noqa: E501

        :return: The date of this ApiResponseIndexConstituents.  # noqa: E501
        :rtype: date
        """
        return self._date
        
    @property
    def date_dict(self):
        """Gets the date of this ApiResponseIndexConstituents.  # noqa: E501

        The date when an update was last received for the index constituents as a dictionary. Useful for Panda Dataframes.  # noqa: E501

        :return: The date of this ApiResponseIndexConstituents.  # noqa: E501
        :rtype: date
        """

        result = None

        value = self.date
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'date': value }

        
        return result
        

    @date.setter
    def date(self, date):
        """Sets the date of this ApiResponseIndexConstituents.

        The date when an update was last received for the index constituents  # noqa: E501

        :param date: The date of this ApiResponseIndexConstituents.  # noqa: E501
        :type: date
        """

        self._date = date

    @property
    def constituents(self):
        """Gets the constituents of this ApiResponseIndexConstituents.  # noqa: E501


        :return: The constituents of this ApiResponseIndexConstituents.  # noqa: E501
        :rtype: list[SecuritySummary]
        """
        return self._constituents
        
    @property
    def constituents_dict(self):
        """Gets the constituents of this ApiResponseIndexConstituents.  # noqa: E501


        :return: The constituents of this ApiResponseIndexConstituents.  # noqa: E501
        :rtype: list[SecuritySummary]
        """

        result = None

        value = self.constituents
        if isinstance(value, list):
            result = list(map(
                lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                value
            ))
        elif hasattr(value, "to_dict"):
            result = value.to_dict()
        elif isinstance(value, dict):
            result = dict(map(
                lambda item: (item[0], item[1].to_dict())
                if hasattr(item[1], "to_dict") else item,
                value.items()
            ))
        else:
            result = { 'constituents': value }

        
        return result
        

    @constituents.setter
    def constituents(self, constituents):
        """Sets the constituents of this ApiResponseIndexConstituents.


        :param constituents: The constituents of this ApiResponseIndexConstituents.  # noqa: E501
        :type: list[SecuritySummary]
        """

        self._constituents = constituents

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ApiResponseIndexConstituents):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
